package org.hathitrust.extractedfeatures;

import org.apache.spark.util.DoubleAccumulator;

public class BasePerJSON 
{
	private static final long serialVersionUID = 1L;

	protected String _input_dir;
	protected String _solr_url;
	protected String _output_dir;
	protected int    _verbosity;
	
	protected DoubleAccumulator _progress_accum;
	protected double            _progress_step;
	
	public BasePerJSON()
	{
		_input_dir = null;
		_solr_url  = null;
		_output_dir = null;
		_verbosity  = 0;
		
		_progress_accum = null;
		_progress_step = 0.0;
	}
	
	public BasePerJSON(String input_dir, String solr_url, String output_dir, int verbosity, 
					   DoubleAccumulator progress_accum, double progress_step)
	{
		_input_dir  = input_dir;
		_solr_url   = solr_url;
		_output_dir = output_dir;
		_verbosity  = verbosity;
		
		_progress_accum = progress_accum;
		_progress_step  = progress_step;
	}
}

